diff -Naurd cluster-3.0.0.rc2/gfs/libgfs/fs_dir.c cluster-3.0.0.rc3/gfs/libgfs/fs_dir.c
--- cluster-3.0.0.rc2/gfs/libgfs/fs_dir.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/libgfs/fs_dir.c	2009-06-11 11:02:55.000000000 +0200
@@ -199,19 +199,19 @@
 /**
  * get_first_leaf - Get first leaf
  * @dip: The GFS inode
- * @index:
+ * @lindex:
  * @bh_out:
  *
  * Returns: 0 on success, error code otherwise
  */
 
-int get_first_leaf(int disk_fd, struct gfs_inode *dip, uint32 index,
+int get_first_leaf(int disk_fd, struct gfs_inode *dip, uint32 lindex,
 				   osi_buf_t **bh_out)
 {
 	uint64 leaf_no;
 	int error;
 
-	error = get_leaf_nr(disk_fd, dip, index, &leaf_no);
+	error = get_leaf_nr(disk_fd, dip, lindex, &leaf_no);
 	if (!error)
 		error = get_leaf(disk_fd, dip, leaf_no, bh_out);
 
@@ -348,7 +348,7 @@
 			      struct gfs_dirent **dent_prev, osi_buf_t **bh_out)
 {
 	osi_buf_t *bh = NULL, *bh_next;
-	uint32 hsize, index;
+	uint32 hsize, lindex;
 	uint32 hash;
 	int error = 0;
 
@@ -362,9 +362,9 @@
 
 	if(id->type == ID_FILENAME){
 		hash = dir_hash(id->filename);
-		index = hash >> (32 - dip->i_di.di_depth);
+		lindex = hash >> (32 - dip->i_di.di_depth);
 
-		error = get_first_leaf(disk_fd, dip, index, &bh_next);
+		error = get_first_leaf(disk_fd, dip, lindex, &bh_next);
 		if (error){
 			return error;
 		}
@@ -395,8 +395,8 @@
 
 		relse_buf(bh);
 	} else if(id->type == ID_INUM){
-		for(index=0; index < (1 << dip->i_di.di_depth); index++){
-			error = get_first_leaf(disk_fd, dip, index, &bh_next);
+		for(lindex=0; lindex < (1 << dip->i_di.di_depth); lindex++){
+			error = get_first_leaf(disk_fd, dip, lindex, &bh_next);
 			if (error){
 				return error;
 			}
@@ -728,12 +728,12 @@
 /**
  * dir_split_leaf - Split a leaf block into two
  * @dip: The GFS inode
- * @index:
+ * @lindex:
  * @leaf_no:
  *
  * Returns: 0 on success, error code on failure
  */
-static int dir_split_leaf(int disk_fd, struct gfs_inode *dip, uint32 index,
+static int dir_split_leaf(int disk_fd, struct gfs_inode *dip, uint32 lindex,
 						  uint64 leaf_no)
 {
 	struct gfs_sbd *sdp = dip->i_sbd;
@@ -792,7 +792,7 @@
 	}
 	half_len = len >> 1;
 
-	start = (index & ~(len - 1));
+	start = (lindex & ~(len - 1));
 
 	log_debug("Splitting leaf: len = %u, half_len = %u\n", len, half_len);
 
@@ -1070,7 +1070,7 @@
 
 
 static int dir_e_del(int disk_fd, struct gfs_inode *dip, osi_filename_t *filename){
-	int index;
+	int lindex;
 	int error;
 	int found = 0;
 	uint64 leaf_no;
@@ -1082,10 +1082,10 @@
 	id.filename = filename;
 	id.inum = NULL;
 
-	index = (1 << (dip->i_di.di_depth))-1;
+	lindex = (1 << (dip->i_di.di_depth))-1;
 
-	for(; (index >= 0) && !found; index--){
-		error = get_leaf_nr(disk_fd, dip, index, &leaf_no);
+	for(; (lindex >= 0) && !found; lindex--){
+		error = get_leaf_nr(disk_fd, dip, lindex, &leaf_no);
 		if (error){
 			log_err("dir_e_del:  Unable to get leaf number.\n");
 			return error;
@@ -1230,7 +1230,7 @@
 	osi_buf_t *bh, *nbh, *dibh;
 	struct gfs_leaf *leaf, *nleaf;
 	struct gfs_dirent *dent;
-	uint32 hsize, index;
+	uint32 hsize, lindex;
 	uint32 hash;
 	uint64 leaf_no, bn;
 	int error;
@@ -1248,10 +1248,10 @@
 	/*  Figure out the address of the leaf node.  */
 
 	hash = dir_hash(filename);
-	index = hash >> (32 - dip->i_di.di_depth);
+	lindex = hash >> (32 - dip->i_di.di_depth);
 
 
-	error = get_leaf_nr(disk_fd, dip, index, &leaf_no);
+	error = get_leaf_nr(disk_fd, dip, lindex, &leaf_no);
 	if (error){
 		log_err("dir_e_add:  Unable to get leaf number.\n");
 		return error;
@@ -1275,7 +1275,7 @@
 				/*  Can we split the leaf?  */
 				relse_buf(bh);
 
-				error = dir_split_leaf(disk_fd, dip, index, leaf_no);
+				error = dir_split_leaf(disk_fd, dip, lindex, leaf_no);
 				if (error){
 					log_err("dir_e_add:  Unable to split leaf.\n");
 					return error;
@@ -1600,21 +1600,21 @@
 
 
 /**
- * get_leaf_nr - Get a leaf number associated with the index
+ * get_leaf_nr - Get a leaf number associated with the lindex
  * @dip: The GFS inode
- * @index:
+ * @lindex:
  * @leaf_out:
  *
  * Returns: 0 on success, error code otherwise
  */
 
-int get_leaf_nr(int disk_fd, struct gfs_inode *dip, uint32 index,
+int get_leaf_nr(int disk_fd, struct gfs_inode *dip, uint32 lindex,
 				uint64 *leaf_out)
 {
 	uint64 leaf_no;
 	int error = -1;
 	error = readi(disk_fd, dip, (char *)&leaf_no,
-				  index * sizeof(uint64), sizeof(uint64));
+				  lindex * sizeof(uint64), sizeof(uint64));
 	if (error != sizeof(uint64)){
 		log_debug("get_leaf_nr:  Bad internal read.  (rtn = %d)\n",
 			  error);
diff -Naurd cluster-3.0.0.rc2/gfs/libgfs/fs_inode.c cluster-3.0.0.rc3/gfs/libgfs/fs_inode.c
--- cluster-3.0.0.rc2/gfs/libgfs/fs_inode.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/libgfs/fs_inode.c	2009-06-11 11:02:55.000000000 +0200
@@ -173,7 +173,7 @@
 	return error;
 }
 
-int fs_createi(int disk_fd, struct gfs_inode *dip, osi_filename_t *name,
+static int fs_createi(int disk_fd, struct gfs_inode *dip, osi_filename_t *name,
 	       unsigned int type, unsigned int mode, osi_cred_t *cred,
 	       int *new, struct gfs_inode **ipp)
 {
@@ -369,7 +369,7 @@
 	struct gfs_inode *ip= NULL;
 	struct gfs_sbd *sdp = dip->i_sbd;
 	osi_filename_t name;
-	int new;
+	int new = 0;
 
 	name.name = (unsigned char *)new_dir;
 	name.len = strlen(new_dir);
diff -Naurd cluster-3.0.0.rc2/gfs/libgfs/libgfs.h cluster-3.0.0.rc3/gfs/libgfs/libgfs.h
--- cluster-3.0.0.rc2/gfs/libgfs/libgfs.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/libgfs/libgfs.h	2009-06-11 11:02:55.000000000 +0200
@@ -202,7 +202,7 @@
 
 void increase_verbosity(void);
 void decrease_verbosity(void);
-void print_log_level(int iif, int priority, char *file, int line, const char *format, ...);
+void print_log_level(int iif, int priority, const char *file, int line, const char *format, ...);
 int query(struct options *opts, const char *format, ...);
 
 /* ------------------------------------------------------------------------- */
@@ -380,13 +380,16 @@
 /* ------------------------------------------------------------------------- */
 /* formerly super.h:                                                         */
 /* ------------------------------------------------------------------------- */
+int hexdump(uint64 startaddr, const unsigned char *lpBuffer, int len);
 int read_sb(int disk_fd, struct gfs_sbd *sdp);
 int ji_update(int disk_fd, struct gfs_sbd *sdp);
 int ri_update(int disk_fd, struct gfs_sbd *sdp);
+void ri_cleanup(osi_list_t *rglist);
 int write_sb(int disk_fd, struct gfs_sbd *sdp);
 int set_block_ranges(int disk_fd, struct gfs_sbd *sdp);
 int read_super_block(int disk_fd, struct gfs_sbd *sdp);
 int compute_constants(struct gfs_sbd *sdp);
+uint32 rgrplength2bitblocks(struct gfs_sbd *sdp, uint32 length);
 
 /* ------------------------------------------------------------------------- */
 /* formerly rgrp.h:                                                          */
diff -Naurd cluster-3.0.0.rc2/gfs/libgfs/log.c cluster-3.0.0.rc3/gfs/libgfs/log.c
--- cluster-3.0.0.rc2/gfs/libgfs/log.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/libgfs/log.c	2009-06-11 11:02:55.000000000 +0200
@@ -26,7 +26,7 @@
 	_state.print_level--;
 }
 
-void print_msg(int priority, char *file, int line, const char *format, va_list args) {
+static void print_msg(int priority, const char *file, int line, const char *format, va_list args) {
 
 	switch (priority) {
 
@@ -48,7 +48,7 @@
 	return;
 }
 
-void print_log_level(int iif, int priority, char *file, int line, const char *format, ...)
+void print_log_level(int iif, int priority, const char *file, int line, const char *format, ...)
 {
 
 	va_list args;
diff -Naurd cluster-3.0.0.rc2/gfs/libgfs/ondisk.c cluster-3.0.0.rc3/gfs/libgfs/ondisk.c
--- cluster-3.0.0.rc2/gfs/libgfs/ondisk.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/libgfs/ondisk.c	2009-06-11 11:02:55.000000000 +0200
@@ -37,7 +37,7 @@
  */
 
 static void
-print_array(char *title, char *buf, int count)
+print_array(const char *title, char *buf, int count)
 {
 	int x;
 
@@ -332,20 +332,20 @@
  */
 
 void
-gfs_rindex_in(struct gfs_rindex *rindex, char *buf)
+gfs_rindex_in(struct gfs_rindex *grindex, char *buf)
 {
 	struct gfs_rindex *str = (struct gfs_rindex *) buf;
 
-	CPIN_64(rindex, str, ri_addr);
-	CPIN_32(rindex, str, ri_length);
-	CPIN_32(rindex, str, ri_pad);
+	CPIN_64(grindex, str, ri_addr);
+	CPIN_32(grindex, str, ri_length);
+	CPIN_32(grindex, str, ri_pad);
 
-	CPIN_64(rindex, str, ri_data1);
-	CPIN_32(rindex, str, ri_data);
+	CPIN_64(grindex, str, ri_data1);
+	CPIN_32(grindex, str, ri_data);
 
-	CPIN_32(rindex, str, ri_bitbytes);
+	CPIN_32(grindex, str, ri_bitbytes);
 
-	CPIN_08(rindex, str, ri_reserved, 64);
+	CPIN_08(grindex, str, ri_reserved, 64);
 
 }
 
@@ -357,20 +357,20 @@
  */
 
 void
-gfs_rindex_out(struct gfs_rindex *rindex, char *buf)
+gfs_rindex_out(struct gfs_rindex *grindex, char *buf)
 {
 	struct gfs_rindex *str = (struct gfs_rindex *) buf;
 
-	CPOUT_64(rindex, str, ri_addr);
-	CPOUT_32(rindex, str, ri_length);
-	CPOUT_32(rindex, str, ri_pad);
+	CPOUT_64(grindex, str, ri_addr);
+	CPOUT_32(grindex, str, ri_length);
+	CPOUT_32(grindex, str, ri_pad);
 
-	CPOUT_64(rindex, str, ri_data1);
-	CPOUT_32(rindex, str, ri_data);
+	CPOUT_64(grindex, str, ri_data1);
+	CPOUT_32(grindex, str, ri_data);
 
-	CPOUT_32(rindex, str, ri_bitbytes);
+	CPOUT_32(grindex, str, ri_bitbytes);
 
-	CPOUT_08(rindex, str, ri_reserved, 64);
+	CPOUT_08(grindex, str, ri_reserved, 64);
 
 }
 
@@ -787,7 +787,7 @@
  */
 
 void
-gfs_dirent_print(struct gfs_dirent *de, char *name)
+gfs_dirent_print(struct gfs_dirent *de, const char *name)
 {
 	char buf[GFS_FNAMESIZE + 1];
 
diff -Naurd cluster-3.0.0.rc2/gfs/libgfs/util.c cluster-3.0.0.rc3/gfs/libgfs/util.c
--- cluster-3.0.0.rc2/gfs/libgfs/util.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/libgfs/util.c	2009-06-11 11:02:55.000000000 +0200
@@ -86,13 +86,13 @@
  */
 int check_meta(osi_buf_t *bh, int type){
   uint32 check_magic = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_magic;
-  uint32 check_type = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_type;
+  uint32 check_metatype = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_type;
  
   check_magic = gfs32_to_cpu(check_magic);
-  check_type = gfs32_to_cpu(check_type);
-  if((check_magic != GFS_MAGIC) || (type && (check_type != type))){
+  check_metatype = gfs32_to_cpu(check_metatype);
+  if((check_magic != GFS_MAGIC) || (type && (check_metatype != type))){
 	  log_debug("For %"PRIu64" Expected %X:%X - got %X:%X\n", BH_BLKNO(bh), GFS_MAGIC, type,
-		    check_magic, check_type);
+		    check_magic, check_metatype);
     return -1;
   }
   return 0;
@@ -107,11 +107,11 @@
  */
 int check_type(osi_buf_t *bh, int type){
   uint32 check_magic = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_magic;
-  uint32 check_type = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_type;
+  uint32 check_metatype = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_type;
  
   check_magic = gfs32_to_cpu(check_magic);
-  check_type = gfs32_to_cpu(check_type);
-  if((check_magic != GFS_MAGIC) || (check_type != type)){
+  check_metatype = gfs32_to_cpu(check_metatype);
+  if((check_magic != GFS_MAGIC) || (check_metatype != type)){
     return -1;
   }
   return 0;
diff -Naurd cluster-3.0.0.rc2/gfs2/convert/gfs2_convert.c cluster-3.0.0.rc3/gfs2/convert/gfs2_convert.c
--- cluster-3.0.0.rc2/gfs2/convert/gfs2_convert.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/convert/gfs2_convert.c	2009-06-11 11:02:55.000000000 +0200
@@ -131,7 +131,6 @@
 struct timeval tv;
 uint64_t dirs_fixed;
 uint64_t dirents_fixed;
-char *prog_name = "gfs2_convert"; /* needed by libgfs2 */
 struct gfs1_jindex *sd_jindex = NULL;    /* gfs1 journal index in memory */
 int gfs2_inptrs;
 uint64_t gfs2_heightsize[GFS2_MAX_META_HEIGHT];
@@ -157,7 +156,7 @@
 /*                   Fixes all unallocated metadata bitmap states (which are */
 /*                   valid in gfs1 but invalid in gfs2).                     */
 /* ------------------------------------------------------------------------- */
-void convert_bitmaps(struct gfs2_sbd *sdp, struct rgrp_list *rgd2,
+static void convert_bitmaps(struct gfs2_sbd *sdp, struct rgrp_list *rgd2,
 					 int read_disk)
 {
 	uint32_t blk;
@@ -235,7 +234,7 @@
 /* This is similar to calc_tree_height in libgfs2 but at the point this      */
 /* function is called, I have the wrong (gfs1 not gfs2) constants in place.  */
 /* ------------------------------------------------------------------------- */
-unsigned int calc_gfs2_tree_height(struct gfs2_inode *ip, uint64_t size)
+static unsigned int calc_gfs2_tree_height(struct gfs2_inode *ip, uint64_t size)
 {
 	uint64_t *arr;
 	unsigned int max, height;
@@ -261,7 +260,7 @@
 /* ------------------------------------------------------------------------- */
 /* mp_gfs1_to_gfs2 - convert a gfs1 metapath to a gfs2 metapath.             */
 /* ------------------------------------------------------------------------- */
-void mp_gfs1_to_gfs2(struct gfs2_sbd *sbp, int gfs1_h, int gfs2_h,
+static void mp_gfs1_to_gfs2(struct gfs2_sbd *sbp, int gfs1_h, int gfs2_h,
 		     struct metapath *gfs1mp, struct metapath *gfs2mp)
 {
 	uint64_t lblock;
@@ -301,7 +300,7 @@
 /*                interested in rearranging the metadata while leaving the   */
 /*                actual data blocks intact.                                 */
 /* ------------------------------------------------------------------------- */
-void fix_metatree(struct gfs2_sbd *sbp, struct gfs2_inode *ip,
+static void fix_metatree(struct gfs2_sbd *sbp, struct gfs2_inode *ip,
 		  struct blocklist *blk, uint64_t *first_nonzero_ptr,
 		  unsigned int size)
 {
@@ -415,7 +414,7 @@
 /*                                                                           */
 /* Adapted from gfs2_fsck metawalk.c's build_and_check_metalist              */
 /* ------------------------------------------------------------------------- */
-int adjust_indirect_blocks(struct gfs2_sbd *sbp, struct gfs2_buffer_head *dibh,
+static int adjust_indirect_blocks(struct gfs2_sbd *sbp, struct gfs2_buffer_head *dibh,
 			   struct gfs2_inode *ip)
 {
 	uint32_t gfs2_hgt;
@@ -593,7 +592,7 @@
 /*                                                                           */
 /* Returns: 0 on success, -1 on failure                                      */
 /* ------------------------------------------------------------------------- */
-int adjust_inode(struct gfs2_sbd *sbp, struct gfs2_buffer_head *bh)
+static int adjust_inode(struct gfs2_sbd *sbp, struct gfs2_buffer_head *bh)
 {
 	struct gfs2_inode *inode;
 	struct inode_block *fixdir;
@@ -682,7 +681,7 @@
 /*                                                                           */
 /* Returns: 0 on success, -1 on failure                                      */
 /* ------------------------------------------------------------------------- */
-int inode_renumber(struct gfs2_sbd *sbp, uint64_t root_inode_addr)
+static int inode_renumber(struct gfs2_sbd *sbp, uint64_t root_inode_addr)
 {
 	struct rgrp_list *rgd;
 	osi_list_t *tmp;
@@ -773,7 +772,7 @@
 /* ------------------------------------------------------------------------- */
 /* fetch_inum - fetch an inum entry from disk, given its block               */
 /* ------------------------------------------------------------------------- */
-int fetch_inum(struct gfs2_sbd *sbp, uint64_t iblock,
+static int fetch_inum(struct gfs2_sbd *sbp, uint64_t iblock,
 					   struct gfs2_inum *inum)
 {
 	struct gfs2_buffer_head *bh_fix;
@@ -795,7 +794,7 @@
 /*                                                                           */
 /* Returns: 0 on success, -1 on failure                                      */
 /* ------------------------------------------------------------------------- */
-int process_dirent_info(struct gfs2_inode *dip, struct gfs2_sbd *sbp,
+static int process_dirent_info(struct gfs2_inode *dip, struct gfs2_sbd *sbp,
 						struct gfs2_buffer_head *bh, int dir_entries)
 {
 	int error;
@@ -885,7 +884,7 @@
 /*                                                                           */
 /* Returns: 0 on success, -1 on failure                                      */
 /* ------------------------------------------------------------------------- */
-int fix_one_directory_exhash(struct gfs2_sbd *sbp, struct gfs2_inode *dip)
+static int fix_one_directory_exhash(struct gfs2_sbd *sbp, struct gfs2_inode *dip)
 {
 	struct gfs2_buffer_head *bh_leaf;
 	int error;
@@ -931,7 +930,7 @@
 /* fix_directory_info - sync new inode numbers with directory info           */
 /* Returns: 0 on success, -1 on failure                                      */
 /* ------------------------------------------------------------------------- */
-int fix_directory_info(struct gfs2_sbd *sbp, osi_list_t *dirs_to_fix)
+static int fix_directory_info(struct gfs2_sbd *sbp, osi_list_t *dir_to_fix)
 {
 	osi_list_t *tmp, *fix;
 	struct inode_block *dir_iblk;
@@ -948,7 +947,7 @@
 	offset = 0;
 	tmp = NULL;
 	/* for every directory in the list */
-	for (fix = dirs_to_fix->next; fix != dirs_to_fix; fix = fix->next) {
+	for (fix = dir_to_fix->next; fix != dir_to_fix; fix = fix->next) {
 		if (tmp) {
 			osi_list_del(tmp);
 			free(tmp);
@@ -989,7 +988,7 @@
 /* ------------------------------------------------------------------------- */
 /* Fetch gfs1 jindex structure from buffer                                   */
 /* ------------------------------------------------------------------------- */
-void gfs1_jindex_in(struct gfs1_jindex *jindex, char *buf)
+static void gfs1_jindex_in(struct gfs1_jindex *jindex, char *buf)
 {
 	struct gfs1_jindex *str = (struct gfs1_jindex *)buf;
 
@@ -1002,7 +1001,7 @@
 /* read_gfs1_jiindex - read the gfs1 jindex file.                            */
 /* Returns: 0 on success, -1 on failure                                      */
 /* ------------------------------------------------------------------------- */
-int read_gfs1_jiindex(struct gfs2_sbd *sdp)
+static int read_gfs1_jiindex(struct gfs2_sbd *sdp)
 {
 	struct gfs2_inode *ip = sdp->md.jiinode;
 	char buf[sizeof(struct gfs1_jindex)];
@@ -1181,7 +1180,7 @@
 /* ------------------------------------------------------------------------- */
 /* give_warning - give the all-important warning message.                    */
 /* ------------------------------------------------------------------------- */
-void give_warning(void)
+static void give_warning(void)
 {
 	printf("This program will convert a gfs1 filesystem to a "	\
 		   "gfs2 filesystem.\n");
@@ -1196,7 +1195,7 @@
 /* ------------------------------------------------------------------------- */
 /* version  - print version information                                      */
 /* ------------------------------------------------------------------------- */
-void version(void)
+static void version(void)
 {
 	log_notice("gfs2_convert version %s (built %s %s)\n", RELEASE_VERSION,
 			   __DATE__, __TIME__);
@@ -1206,7 +1205,7 @@
 /* ------------------------------------------------------------------------- */
 /* usage - print usage information                                           */
 /* ------------------------------------------------------------------------- */
-void usage(const char *name)
+static void usage(const char *name)
 {
 	give_warning();
 	printf("\nUsage:\n");
@@ -1223,7 +1222,7 @@
 /* ------------------------------------------------------------------------- */
 /* process_parameters                                                        */
 /* ------------------------------------------------------------------------- */
-void process_parameters(int argc, char **argv, struct gfs2_options *opts)
+static void process_parameters(int argc, char **argv, struct gfs2_options *opts)
 
 {
 	char c;
@@ -1279,7 +1278,7 @@
 /* rgrp_length - Calculate the length of a resource group                    */
 /* @size: The total size of the resource group                               */
 /* ------------------------------------------------------------------------- */
-uint64_t rgrp_length(uint64_t size, struct gfs2_sbd *sdp)
+static uint64_t rgrp_length(uint64_t size, struct gfs2_sbd *sdp)
 {
 	uint64_t bitbytes = RGRP_BITMAP_BLKS(&sdp->sd_sb) + 1;
 	uint64_t stuff = RGRP_STUFFED_BLKS(&sdp->sd_sb) + 1;
@@ -1308,7 +1307,7 @@
 /*                                                                           */
 /* Returns: 0 on success, -1 on failure                                      */
 /* ------------------------------------------------------------------------- */
-int journ_space_to_rg(struct gfs2_sbd *sdp)
+static int journ_space_to_rg(struct gfs2_sbd *sdp)
 {
 	int error = 0;
 	int j, x;
@@ -1391,7 +1390,7 @@
 /* ------------------------------------------------------------------------- */
 /* update_inode_file - update the inode file with the new next_inum          */
 /* ------------------------------------------------------------------------- */
-void update_inode_file(struct gfs2_sbd *sdp)
+static void update_inode_file(struct gfs2_sbd *sdp)
 {
 	struct gfs2_inode *ip = sdp->md.inum;
 	uint64_t buf;
@@ -1408,7 +1407,7 @@
 /* ------------------------------------------------------------------------- */
 /* write_statfs_file - write the statfs file                                 */
 /* ------------------------------------------------------------------------- */
-void write_statfs_file(struct gfs2_sbd *sdp)
+static void write_statfs_file(struct gfs2_sbd *sdp)
 {
 	struct gfs2_inode *ip = sdp->md.statfs;
 	struct gfs2_statfs_change sc;
@@ -1428,7 +1427,7 @@
 /* ------------------------------------------------------------------------- */
 /* remove_obsolete_gfs1 - remove obsolete gfs1 inodes.                       */
 /* ------------------------------------------------------------------------- */
-void remove_obsolete_gfs1(struct gfs2_sbd *sbp)
+static void remove_obsolete_gfs1(struct gfs2_sbd *sbp)
 {
 	struct gfs2_inum inum;
 
@@ -1454,7 +1453,7 @@
 /* ------------------------------------------------------------------------- */
 /* lifted from libgfs2/structures.c                                          */
 /* ------------------------------------------------------------------------- */
-void conv_build_jindex(struct gfs2_sbd *sdp)
+static void conv_build_jindex(struct gfs2_sbd *sdp)
 {
 	struct gfs2_inode *jindex;
 	unsigned int j;
@@ -1502,10 +1501,10 @@
 	/* Make them seal their fate.                     */
 	/* ---------------------------------------------- */
 	if (!error) {
-		int abort;
+		int do_abort;
 
 		give_warning();
-		if (!gfs2_query(&abort, &opts,
+		if (!gfs2_query(&do_abort, &opts,
 				"Convert %s from GFS1 to GFS2? (y/n)",
 				device)) {
 			log_crit("%s not converted.\n", device);
diff -Naurd cluster-3.0.0.rc2/gfs2/edit/gfs2hex.c cluster-3.0.0.rc3/gfs2/edit/gfs2hex.c
--- cluster-3.0.0.rc2/gfs2/edit/gfs2hex.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/edit/gfs2hex.c	2009-06-11 11:02:55.000000000 +0200
@@ -69,6 +69,8 @@
 int insert = 0;
 const char *termtype;
 WINDOW *wind;
+int dsplines = 0;
+
 const char *block_type_str[15] = {
 	"Clump",
 	"Superblock",
@@ -115,7 +117,7 @@
 	va_end(args);
 }
 
-void check_highlight(int highlight)
+static void check_highlight(int highlight)
 {
 	if (!termlines || line >= termlines) /* If printing or out of bounds */
 		return;
@@ -219,7 +221,7 @@
 	}
 }
 
-int indirect_dirent(struct indirect_info *indir, char *ptr, int d)
+static int indirect_dirent(struct indirect_info *indir, char *ptr, int d)
 {
 	struct gfs2_dirent de;
 
@@ -255,20 +257,20 @@
 **
 *******************************************************************************
 ******************************************************************************/
-void do_dinode_extended(struct gfs2_dinode *di, char *buf)
+void do_dinode_extended(struct gfs2_dinode *dine, char *dinebuf)
 {
 	unsigned int x, y;
 	uint64_t p, last;
-	int isdir = !!(S_ISDIR(di->di_mode)) || 
-		(gfs1 && di->__pad1 == GFS_FILE_DIR);
+	int isdir = !!(S_ISDIR(dine->di_mode)) || 
+		(gfs1 && dine->__pad1 == GFS_FILE_DIR);
 
 	indirect_blocks = 0;
 	memset(indirect, 0, sizeof(indirect));
-	if (di->di_height > 0) {
+	if (dine->di_height > 0) {
 		/* Indirect pointers */
 		for (x = sizeof(struct gfs2_dinode); x < sbd.bsize;
 			 x += sizeof(uint64_t)) {
-			p = be64_to_cpu(*(uint64_t *)(buf + x));
+			p = be64_to_cpu(*(uint64_t *)(dinebuf + x));
 			if (p) {
 				indirect->ii[indirect_blocks].block = p;
 				indirect->ii[indirect_blocks].is_dir = FALSE;
@@ -276,7 +278,7 @@
 			}
 		}
 	}
-	else if (isdir && !(di->di_flags & GFS2_DIF_EXHASH)) {
+	else if (isdir && !(dine->di_flags & GFS2_DIF_EXHASH)) {
 		int skip = 0;
 
 		/* Directory Entries: */
@@ -285,25 +287,25 @@
 		indirect->ii[0].is_dir = TRUE;
 		for (x = sizeof(struct gfs2_dinode); x < sbd.bsize; x += skip) {
 			skip = indirect_dirent(indirect->ii,
-					       buf + x,
+					       dinebuf + x,
 					       indirect->ii[0].dirents);
 			if (skip <= 0)
 				break;
 		}
 	}
 	else if (isdir &&
-			 (di->di_flags & GFS2_DIF_EXHASH) &&
-			 di->di_height == 0) {
+			 (dine->di_flags & GFS2_DIF_EXHASH) &&
+			 dine->di_height == 0) {
 		/* Leaf Pointers: */
 		
-		last = be64_to_cpu(*(uint64_t *)(buf + sizeof(struct gfs2_dinode)));
+		last = be64_to_cpu(*(uint64_t *)(dinebuf + sizeof(struct gfs2_dinode)));
     
 		for (x = sizeof(struct gfs2_dinode), y = 0;
-			 y < (1 << di->di_depth);
+			 y < (1 << dine->di_depth);
 			 x += sizeof(uint64_t), y++) {
-			p = be64_to_cpu(*(uint64_t *)(buf + x));
+			p = be64_to_cpu(*(uint64_t *)(dinebuf + x));
 
-			if (p != last || ((y + 1) * sizeof(uint64_t) == di->di_size)) {
+			if (p != last || ((y + 1) * sizeof(uint64_t) == dine->di_size)) {
 				struct gfs2_buffer_head *tmp_bh;
 				int skip = 0, direntcount = 0;
 				struct gfs2_leaf leaf;
@@ -347,7 +349,7 @@
 **
 *******************************************************************************
 ******************************************************************************/
-int do_indirect_extended(char *buf, struct iinfo *iinf)
+int do_indirect_extended(char *diebuf, struct iinfo *iinf)
 {
 	unsigned int x, y;
 	uint64_t p;
@@ -359,7 +361,7 @@
 			  sizeof(struct gfs2_meta_header)), y = 0;
 		 x < sbd.bsize;
 		 x += sizeof(uint64_t), y++) {
-		p = be64_to_cpu(*(uint64_t *)(buf + x));
+		p = be64_to_cpu(*(uint64_t *)(diebuf + x));
 		if (p) {
 			iinf->ii[i_blocks].block = p;
 			iinf->ii[i_blocks].is_dir = FALSE;
@@ -384,24 +386,24 @@
 **
 *******************************************************************************
 ******************************************************************************/
-void do_leaf_extended(char *buf, struct iinfo *indir)
+void do_leaf_extended(char *dlebuf, struct iinfo *indir)
 {
 	int x, i;
 	struct gfs2_dirent de;
 
 	x = 0;
-	memset(indir, 0, sizeof(indir));
+	memset(indir, 0, sizeof(*indir));
 	/* Directory Entries: */
 	for (i = sizeof(struct gfs2_leaf); i < sbd.bsize;
 	     i += de.de_rec_len) {
-		gfs2_dirent_in(&de, buf + i);
+		gfs2_dirent_in(&de, dlebuf + i);
 		if (de.de_inum.no_addr) {
 			indir->ii[0].block = de.de_inum.no_addr;
 			indir->ii[0].dirent[x].block = de.de_inum.no_addr;
 			memcpy(&indir->ii[0].dirent[x].dirent,
 			       &de, sizeof(struct gfs2_dirent));
 			memcpy(&indir->ii[0].dirent[x].filename,
-			       buf + i + sizeof(struct gfs2_dirent),
+			       dlebuf + i + sizeof(struct gfs2_dirent),
 			       de.de_name_len);
 			indir->ii[0].dirent[x].filename[de.de_name_len] = '\0';
 			indir->ii[0].is_dir = TRUE;
@@ -430,7 +432,7 @@
 *******************************************************************************
 ******************************************************************************/
 
-void do_eattr_extended(char *buf)
+static void do_eattr_extended(char *deebuf)
 {
 	struct gfs2_ea_header ea;
 	unsigned int x;
@@ -442,12 +444,12 @@
 	for (x = sizeof(struct gfs2_meta_header); x < sbd.bsize; x += ea.ea_rec_len)
 	{
 		eol(0);
-		gfs2_ea_header_in(&ea, buf + x);
-		gfs2_ea_header_print(&ea, buf + x + sizeof(struct gfs2_ea_header));
+		gfs2_ea_header_in(&ea, deebuf + x);
+		gfs2_ea_header_print(&ea, deebuf + x + sizeof(struct gfs2_ea_header));
 	}
 }
 
-void gfs2_inum_print2(const char *title,struct gfs2_inum *no)
+static void gfs2_inum_print2(const char *title,struct gfs2_inum *no)
 {
 	if (termlines) {
 		check_highlight(TRUE);
@@ -467,31 +469,31 @@
  * gfs2_sb_print2 - Print out a superblock
  * @sb: the cpu-order buffer
  */
-void gfs2_sb_print2(struct gfs2_sb *sb)
+static void gfs2_sb_print2(struct gfs2_sb *sbp2)
 {
-	gfs2_meta_header_print(&sb->sb_header);
+	gfs2_meta_header_print(&sbp2->sb_header);
 
-	pv(sb, sb_fs_format, "%u", "0x%x");
-	pv(sb, sb_multihost_format, "%u", "0x%x");
+	pv(sbp2, sb_fs_format, "%u", "0x%x");
+	pv(sbp2, sb_multihost_format, "%u", "0x%x");
 
-	pv(sb, sb_bsize, "%u", "0x%x");
-	pv(sb, sb_bsize_shift, "%u", "0x%x");
+	pv(sbp2, sb_bsize, "%u", "0x%x");
+	pv(sbp2, sb_bsize_shift, "%u", "0x%x");
 	if (gfs1) {
 		gfs2_inum_print2("jindex ino", &sbd1->sb_jindex_di);
 		gfs2_inum_print2("rindex ino", &sbd1->sb_rindex_di);
 	}
 	else
-		gfs2_inum_print2("master dir", &sb->sb_master_dir);
-	gfs2_inum_print2("root dir  ", &sb->sb_root_dir);
+		gfs2_inum_print2("master dir", &sbp2->sb_master_dir);
+	gfs2_inum_print2("root dir  ", &sbp2->sb_root_dir);
 
-	pv(sb, sb_lockproto, "%s", NULL);
-	pv(sb, sb_locktable, "%s", NULL);
+	pv(sbp2, sb_lockproto, "%s", NULL);
+	pv(sbp2, sb_locktable, "%s", NULL);
 	if (gfs1) {
 		gfs2_inum_print2("quota ino ", &gfs1_quota_di);
 		gfs2_inum_print2("license   ", &gfs1_license_di);
 	}
 #ifdef GFS2_HAS_UUID
-	print_it("  sb_uuid", "%s", NULL, str_uuid(sb->sb_uuid));
+	print_it("  sb_uuid", "%s", NULL, str_uuid(sbp2->sb_uuid));
 #endif
 }
 
diff -Naurd cluster-3.0.0.rc2/gfs2/edit/gfs2hex.h cluster-3.0.0.rc3/gfs2/edit/gfs2hex.h
--- cluster-3.0.0.rc2/gfs2/edit/gfs2hex.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/edit/gfs2hex.h	2009-06-11 11:02:55.000000000 +0200
@@ -1,10 +1,14 @@
 #ifndef __GFS2HEX_DOT_H__
 #define __GFS2HEX_DOT_H__
 
+#include "hexedit.h"
 
 int display_gfs2(void);
 int edit_gfs2(void);
 void do_dinode_extended(struct gfs2_dinode *di, char *buf);
 void print_gfs2(const char *fmt, ...);
+int do_indirect_extended(char *diebuf, struct iinfo *iinf);
+void do_leaf_extended(char *dlebuf, struct iinfo *indir);
+void eol(int col);
 
 #endif /*  __GFS2HEX_DOT_H__  */
